/* $Id: irkey.c,v 1.6 2003/06/14 15:46:02 cochran Exp $
 *
 *  Copyright (c) 2002 Richard Cochran (cochran@cs.umass.edu)
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, or (at your option) any later version.
 */

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>

#define NCODES 34

static char* names[NCODES] = {
  "null", "power on",
  "numeric 1", "numeric 2", "numeric 3",
  "numeric 4", "numeric 5", "numeric 6",
  "numeric 7", "numeric 8", "numeric 9",
  "numeric 0", "CMSS",      "MUTE",
  "REC",       "VOL -",     "VOL +",
  "stop/eject","play/pause","SLOW |>",
  "PREVIOUS",  "NEXT",      "STEP",
  "EAX",       "OPTIONS",   "DISPLAY",
  "RETURN",    "START",     "CANCEL",
  "up arrow",
  "<<",        "SELECT OK", ">>",
  "down arrow"
};

int main(int argc,char* argv[])
{
  int fd;
  unsigned int tmp;
  unsigned short code;

  fd = open("/dev/ir",O_RDONLY);
  if (fd < 0) {
    perror("Cannot open IR device");
    return(-1);
  }
  while (1) {
    if (sizeof(int) != read(fd,&tmp,sizeof(int))) {
      perror("Cannot read IR device");
      return(-1);
    } else {
      code = tmp & 0xFF;
      printf("code=%02u ",code);
      if (code < NCODES)
	printf(": %s\n",names[code]);
      else
	printf("unexpected code\n");
    }
  }
  return(0);
}
