/*	Copyright (C) 2004 Thomas Cougnard, Bertrik Sikken
	
	This file is part of the sonix-cam driver.

    The sonix-cam driver is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    The sonix-cam driver is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with the sonix-cam driver; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
		
#ifndef _SONIX_H_
#define _SONIX_H_

#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/input.h>
#include <linux/vmalloc.h>
#include <linux/version.h>

#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0))
#include "../drivers/usb/usbvideo.h"
#else
#include "../../drivers/media/video/usbvideo/usbvideo.h"
#endif

#if 1
#define sonixcam_debug(str...) info(str)
#else
#define sonixcam_debug(str...)
#endif

#define DEBUG(n, format, arg...) \
	if (n <= debug) {	 \
		printk(KERN_DEBUG __FILE__ ":%s(): " format "\n", __FUNCTION__ , ## arg); \
	}
extern int debug;

struct sn9c102_device {
  u8 size;		/* Frame Size */
  int height;
  int width;
  struct urb *sts_urb[USBVIDEO_NUMSBUF];
  u8 sts_buf[USBVIDEO_NUMSBUF][FRAMES_PER_DESC];
  struct urb *last_data_urb;
  int lastframe;
  int cur_frame_size;	/* number of bytes in current frame size */
  int maxline;		/* number of lines per frame */
  
  int ae_data1;		/* exposure measurement inside AE window */
  int ae_data2;		/* exposure measurement outside AE window */
  
  struct usb_device *usbdev;
  struct sn9c102_sensor *sensor;
};

#endif /* _SONIX_H_ */
