/*	common/initiator_negotiate.h
 *
 *	This defines the functions used in the Login phase
 *	by the iSCSI initiator for parameter negotiation
 *
 *	vi: set autoindent tabstop=8 shiftwidth=4 :
 *
 *	This file contains auxilliary functions for iscsi initiator 
 *	code that are responsible for dealing with error recovery.
 *
 *	Copyright (C) 2001-2003 InterOperability Lab (IOL)
 *	University of New Hampshier (UNH)
 *	Durham, NH 03824
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2, or (at your option)
 *	any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *	USA.
 *
 *	The name of IOL and/or UNH may not be used to endorse or promote 
 *	products derived from this software without specific prior 
 * 	written permission.
*/

/*	The code for redirection during login is based on code first written
 *	by Scott Cranston of Equal Logic (scranston@equallogic.com).
 */

#ifndef	_INITIATOR_NEGOTIATE_H
#define	_INITIATOR_NEGOTIATE_H

/*	check the correctness of target ip address which should be in format of
 *	TargetAddress=domainname[:port][,portal-group-tag]
 */
int check_target_address(char *value, int when);

/* This function is the entry point to this file to perform parameter
 * negotiation on initiator side.
 * Called only from iscsi_initiator_login() in iscsi_initiator.c.
 * Returns 1 on Redirection, 0 on all other successes, -1 on any error.
 */
int initiator_parameter_negotiate(struct socket *sock, 
	struct parameter_type *p_param_tbl, 
	struct auth_parameter_type auth_param,	
	__u32 * cur_cmd_sn,
	__u32 login_task_tag,
	void *isid,
	__u16 *tsih,
	__u16 cid,
	__u32 *connection_flags,
	__u32 version_number,
	__u32 when_called,
	int *exp_stat_sn,
	int *max_send_length, int *max_recv_length);

#endif
