/*  initiator/initiator_proc_iface.h
 *
 *	vi: set autoindent tabstop=8 shiftwidth=8 :
 *
 *  This is the header file for initiator_proc_iface.c
 *
 *	This file contains auxilliary functions for iscsi initiator 
 *	code that are responsible for dealing with error recovery.
 *
 *	Copyright (C) 2001-2004 InterOperability Lab (IOL)
 *	University of New Hampshire (UNH)
 *	Durham, NH 03824
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2, or (at your option)
 *	any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *	USA.
 *
 *	The name of IOL and/or UNH may not be used to endorse or promote 
 *	products derived from this software without specific prior 
 * 	written permission.
*/
#ifdef ISCSI_STATS

#define SESSION    1
#define CONNECTION 2
#define STAT       4
#define CONTROL    8

#define TARGET_FNAME		"target"
#define CONNECTION_FNAME	"conn"
#define STAT_FNAME		"stat"
#define CONTROL_FNAME		"ctrl"

/* RDR change the following define to 1 to use control file!? */
#define USE_CONTROL_FILE	0

/* RDR change the following define to 1 to call print_date */
#define USE_PRINT_DATE		0

struct proc_data {
       __u32 sess_id;	/* Session_id */
       __u32 conn_id;	/* Connection_id */
       __u8 type;	/* Session or Connection */
       __u8 file;	/* Stat or Ctrl */
};

int add_iscsi_proc_entry(void *ptr, int type);
void remove_iscsi_proc_entry(void *ptr, int type);

#endif
