#ifndef h_Zc030x_ISO_h
#define h_Zc030x_ISO_h

/* This file implement the isochronous moves functionnalities */
/* This project is under GPL                                  */
/* - Driver file -            Zc030x       - Driver file -    */ 
/* Copyright: 
               Martin   Braun
               Cyril    Russo

--------------------------------------------------------------*/

/* Include definitions */
#include "zc030x_kerneldef.h"
#include "zc030x.h"




/* Return the next free frame to grab into */
zc030x_frame * zc030x_get_free_frame(struct usb_zc030x *dev);

/* Tasklet main function */
void decode_tasklet (unsigned long ptr);

/* Move the isochronous data received to decoder */
int zc030x_move_data (struct usb_zc030x *dev, struct urb *urb);

/* Isochronous transfers callback */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 0)
void zc030x_isoc_handler (struct urb *urb);
#else
void zc030x_isoc_handler (struct urb *urb,  struct pt_regs *prgx);
#endif


/* Start the isochronous transfers */
int zc030x_isoc_start (struct usb_zc030x *dev);

/* Stop the isochronous transfers */
int zc030x_isoc_stop (struct usb_zc030x *dev);
    
#endif
