#ifndef h_Zc030x_Gamma_h
#define h_Zc030x_Gamma_h

/* This files declares gamma creation      */
/* Driver file -   Zc030x -    Driver file */ 
/* This file is under GPL                  */
/* Copyright :
		Cyril	Russo					   
-------------------------------------------*/

/* Include kernel definitions */
#include "zc030x_kerneldef.h"
/* Include floating over fixed point maths */
#include "zc030x_fp.h"

/* Define gamma array size */
#define GammaArraySize			32
/* Clip to [0:255] range */
#define Clip(X)					((X) < 0 ? 0 : ((X) > 255 ? 255 : (X))) 

/* Now declare the series */
/* Floating point numbers using Fixed point maths */
typedef struct 
{
	FPNum a[5];		/* The x^i coefficient */
} FPGammaGenerator;
/* Same thing but with strings (needed to initialize the previous table) */
typedef struct 
{
	const char * a[5];		/* The x^i coefficient */
} StrGammaGenerator;

/* The function that output the gamma array */
/* dGamma should be in [1;5], I have no idea if it's real gamma */
/* dBrightness should be in [-1;1], 0 for no change */
/* dContrast should be in [-1;1], 0 for no change */
const __u8 * zc030x_gamma_create(const char * acGamma, const char * acBrightness, const char * acContrast);

/* This function is the same as the above one, except that it directly takes FPNum */
const __u8 * zc030x_gamma_create_FPNum(FPNum dGamma, FPNum dBrightness, FPNum dContrast);


/* Initialize the arrays (should be done once) */
int zc030x_gamma_init(void);

#endif
