#ifndef h_Zc030x_MM_h
#define h_Zc030x_MM_h

/* This file implement the memory management functionnalities */
/* This project is under GPL                                  */
/* - Driver file -            Zc030x       - Driver file -    */ 
/* Copyright: 
               Tommy
               Cyril    Russo

--------------------------------------------------------------*/

/* Include headers */
#include "zc030x_kerneldef.h"

/* Given PGD from the address space's page table, return the kernel
   virtual mapping of the physical memory mapped at ADR.           */
unsigned long uvirt_to_kva(pgd_t *pgd, unsigned long adr);

/* Return the physical address of a kernel virtual mapping */
unsigned long kvirt_to_pa(unsigned long adr);

/* Alloc memory */ 
void * rvmalloc(unsigned long size);

/* Free memory */
void   rvfree(void *mem, unsigned long size);

/* Allocate isochronous urbs */
int zc030x_allocate_urbs(struct usb_zc030x *dev);

/* Allocate the buffers */
int zc030x_allocate_buffers (struct usb_zc030x *dev);
    
/* Free the buffers */
int zc030x_unallocate_buffers (struct usb_zc030x *dev);


#endif 
