#ifndef h_Zc030x_V4L_h
#define h_Zc030x_V4L_h 

/* Include kernel specific code */
#include "zc030x_kerneldef.h"

/* Define Video for Linux specific error codes */
#define V4L_Error   -1
#define V4L_Warning  0
#define V4L_OK       1

#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 4, 24)
inline void * video_get_drvdata(struct video_device *vdev);

inline void video_set_drvdata(struct video_device *vdev, void *data);

inline struct video_device *video_device_alloc(void);

inline void video_device_release(struct video_device *vdev);
#endif


/* internal functions */
int zc030x_do_ioctl (struct inode *inode, struct file *file, unsigned int cmd, void *arg);

/* Define hardware number */
#define VID_HARDWARE_ZC030X   37

/* Fill the video dynamic device object */
int zc030x_v4l_initdev(struct file_operations * pFops, struct usb_zc030x * pDev, const char * Name, struct usb_device * udev);
/* Release video device */
int zc030x_v4l_releasedev(struct video_device * pVideoDevice);
/* Video for Linux specific IOCTLs */
int zc030x_v4l_ioctl (struct inode *inode, struct file *file, unsigned int cmd, void *arg);
/* Get the depth of pixels */
int zc030x_v4l_getdepth(int Palette);


#endif // __ZC030X_V4L_H
