/*
 * Zoran ZR36015 basic configuration functions - header file
 *
 * Copyright (C) 2001 Wolfgang Scherr <scherr@net4you.at>
 * Copyright (C) 2004 Luca Bonissi <lucabon@interfree.it>
 *
 * $Id: zr36015.h,v 1.1.2.3 2003/01/14 21:18:07 rbultje Exp $
 *
 * ------------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * ------------------------------------------------------------------------
 */

#ifndef ZR36015_H
#define ZR36015_H

/* data stored for each zoran jpeg codec chip */
struct zr36015 {
	char name[32];
	int num;
	/* io datastructure */
	struct videocodec *codec;
	// actual coder setup
	int mode;

	__u16 xoff;
	__u16 yoff;
	__u16 width;
	__u16 height;
	__u16 xdec;
};

/* direct  register addresses */
#define ZR015_RESET       0x00
#define ZR015_MODE        0x01
#define ZR015_IADDR       0x02
#define ZR015_IDATA       0x03

/* indirect  register addresses */
#define ZR015I_HD_LO     0x00
#define ZR015I_HD_HI     0x01
#define ZR015I_HW_LO     0x02
#define ZR015I_HW_HI     0x03
#define ZR015I_VD_LO     0x04
#define ZR015I_VD_HI     0x05
#define ZR015I_VW_LO     0x06
#define ZR015I_VW_HI     0x07
#define ZR015I_NOL_LO    0x08
#define ZR015I_NOL_HI    0x09

/* mask for mode register */
#define ZR015_MASK_GO    0x01
#define ZR015_MASK_EDC   0x02
#define ZR015_MASK_MOD   0x0c
#define ZR015_MASK_DCM   0x10
#define ZR015_MASK_CSC   0x20
#define ZR015_MASK_BSY   0x80

/* possible values for mode register */
#define ZR015_GO             0x01

#define ZR015_EXPANSION      0x00
#define ZR015_DECODE         0x00
#define ZR015_COMPRESSION    0x02
#define ZR015_ENCODE         0x02

#define ZR015_DECIMATE       0x10

#define ZR015_YUV100_YUV100  0x00
#define ZR015_YUV422_YUV422  0x04
#define ZR015_YUV422_YUV411  0x08
#define ZR015_YUV411_YUV411  0x0c


#endif				/*fndef ZR36016_H */
